app/blueprints/account_area/views.py
from flask import Blueprint, render_template, request, redirect, url_for
from flask_login import login_required, current_user

from app.models import User, Message, db

account_area = Blueprint('account_area', __name__, template_folder='templates')


@account_area.route('/')
@login_required
def index():
    return render_template('account_area/account_area.html')


@account_area.route('/change_password', methods=['POST'])
@login_required
def change_password():
    form_data = request.form
    current_password = form_data.get('current-password', None)
    new_password = form_data.get('new-password', None)
    confirm_password = form_data.get('confirm-password', None)

    error = ''
    if not (current_password and new_password and confirm_password):
        error = 'Please specify all fields'
    if not current_user.password == current_password:
        error = 'Current password incorrect'
    if not new_password == confirm_password:
        error = 'Password confirmation doesn\'t match'

    if error:
        return render_template('account_area/account_area.html', error=error)
    else:
        User.query.filter_by(id=current_user.id).update({
            'password': new_password
        })
        db.session.commit()
        return render_template('account_area/account_area.html')


@account_area.route('/change_email', methods=['POST'])
@login_required
def change_email():
    form_data = request.form
    new_email = form_data.get('email', None)

    error = ''
    if not new_email:
        error = 'Please specify an email'

    if error:
        return render_template('account_area/account_area.html', error=error)
    else:
        User.query.filter_by(id=current_user.id).update({
            'email': new_email
        })
        db.session.commit()
        return render_template('account_area/account_area.html')


@account_area.route('/send_feedback', methods=['POST'])
@login_required
def send_feedback():
    form_data = request.form
    print(request.form)
    feedback = form_data.get('feedback', None)

    error = ''
    if not feedback:
        error = 'Please specify feedback to send'

    if error:
        return render_template('account_area/account_area.html', error=error)
    else:
        new_message = Message(message=feedback, from_user=current_user.username)
        db.session.add(new_message)
        db.session.commit()
        return render_template('account_area/account_area.html')

app/blueprints/login/views.py
from flask import Blueprint, request, redirect, url_for, render_template
from flask_login import current_user, login_user, logout_user

from app.models import User

authentication = Blueprint('authentication', __name__, template_folder='templates')


@authentication.route('/login', methods=['POST', 'GET'])
def login():
    if current_user.is_authenticated:
        return redirect(url_for('index'))
    elif request.method == 'POST':
        username = request.form.get('username', None)
        password = request.form.get('password', None)
        user = User.query.filter_by(username=username).first()
        if user and user.password == password:
            login_user(user)
            return redirect(url_for('index'))
        else:
            return render_template('login/login.html', error='There was a problem logging in')

    else:
        return render_template('login/login.html')


@authentication.route('/logout', methods=['POST', 'GET'])
def logout():
    logout_user()
    return redirect(url_for('index'))

app/blueprints/xss_protection/views.py
from flask import Blueprint, session, request, url_for, redirect

xss_protection = Blueprint('xss_protection', __name__)


@xss_protection.route('/')
def index():
    xss_protection_enabled = session.get('xss_protection_enabled', False)
    session['xss_protection_enabled'] = not xss_protection_enabled

    next = request.args.get('next', url_for('index'))
    return redirect(next)

app/templates/_base.html
{% from 'components/head.html' import css_head %}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Flask XSS</title>
    {{ css_head() }}
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"
            integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
            crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.11.0/umd/popper.min.js"
            integrity="sha384-b/U6ypiBEHpOf/4+1nzFpr53nxSS+GLCkfwBdFNTxtclqqenISfwAzpKaMNFNmj4"
            crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"
            integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa"
            crossorigin="anonymous"></script>

</head>
<body>
<nav class="navbar navbar-default">
    <div class="container-fluid">
        <button class="navbar-toggle collapsed" type="button" data-toggle="collapse" data-target="#navbarCollapse">
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="{{ url_for("index") }}">
            Flask XSS</a>
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                {% if g.user.is_authenticated %}
                    <li>
                        <a href="{{ url_for("authentication.logout") }}">
                            <button class="btn btn-primary navbar-btn">Logout</button>
                        </a>
                    </li>
                    {% if g.user.is_admin %}
                        <li>
                            <a href="{{ url_for("admin.index") }}">
                                <button class="btn btn-success navbar-btn" type="button">Admin Area</button>
                            </a>
                        </li>
                        <li>
                            <span class="navbar-text">You are logged in as admin</span>
                        </li>
                    {% else %}
                        <li>
                            <a href="{{ url_for("account_area.index") }}">
                                <button class="btn btn-success navbar-btn" type="button">Account Area</button>
                            </a>
                        </li>
                        <li>
                            <span class="navbar-text">You are logged in as a regular user: {{ g.user.username | safe }}</span>
                        </li>
                    {% endif %}
                {% else %}
                    <li>
                        <a href="{{ url_for("authentication.login") }}">
                            <button class="btn btn-primary navbar-btn">Login</button>
                        </a>
                    </li>
                {% endif %}
            </ul>

            <form class="navbar-form navbar-right" method="GET" action={{ url_for('xss_protection.index') }}>
                <input name="next" type="hidden" value={{ g.path }}>
                {% if g.session['xss_protection_enabled'] %}
                    <button class="btn btn-success navbar-btn" type="submit">Protection Enabled</button>
                {% else %}
                    <button class="btn btn-danger navbar-btn" type="submit">Protection Disabled</button>
                {% endif %}
            </form>
        </div>
    </div>
</nav>
{% block body %}
{% endblock %}
<script src={{ url_for("static", filename="test.js") }}></script>
</body>
</html>

app/templates/index.html
{% extends "_base.html" %}

{% block body %}
    <div class="jumbotron">
        <h1>Welcome to Flask XSS</h1>
        <p>An intentionally vulnerable Flask XSS sandbox</p>
    </div>

    <div class="container">
        {% for index, page_name in enumerate(pages.keys()) %}
            {% set max_cards_per_row = 3 %}
            {% if index % max_cards_per_row == 0 %}
                <div class="row">
            {% endif %}
        <div class="card col-md-4">
            <div class="card-body">
                <h4 class="card-title">{{ page_name }}</h4>
                <a href="{{ pages[page_name] }}" class="card-link">{{ page_name }}</a>
            </div>
        </div>

        {% if index % max_cards_per_row == max_cards_per_row-1
                or len(pages) == index - 1%}
            </div>
        {% endif %}
        {% endfor %}
    </div>
{% endblock %}